<template>
  <div>
    <RimowSelectize
      v-if="parentValue && datasetFiles.length"
      placeholder="Select a field..."
      data-cy="dataset-file-dropdown"
      :add-properties="addProperties(parameter, HTMLSelectElement)"
      item-icon="file"
      :options="datasetFiles"
      :selected="selected"
      :disabled="disabled"
      @change="updateDatasetFileField"
    />
    <span v-else-if="parentValue" class="sce-param-value text-muted">
      No csv/tsv files in dataset
    </span>
    <span v-else class="sce-param-value text-muted">No dataset selected</span>
  </div>
</template>

<script>
export default {
  props: {
    parameter: {
      type: Object,
      default: () => {},
    },
    disabled: {
      type: Boolean,
      default: () => false,
    },
    addProperties: {
      type: Function,
      default: () => ({}),
    },
  },
  data() {
    return {
      projectId: this.$nuxt.$route.params.id,
      scenarioId: this.$nuxt.$route.params.scenarioId,
      HTMLSelectElement: null,
    };
  },
  computed: {
    param() {
      return this.$nuxt.context.store.state.parameters.inputMap[
        this.parameter.key
      ];
    },
    parentValue() {
      const datasetParameter =
        this.$nuxt.context.store.state.parameters.inputMap[
          this.param.datasetSelectKey
        ];
      return datasetParameter?.value;
    },
    datasetFiles() {
      if (this.parentValue) {
        let files = this.$nuxt.context.store.getters['datasets/datasetFiles'](
          this.parentValue
        );
        if (this.param.supportedExtensions) {
          files = files.filter((file) => {
            const ext = file.title.split('.').pop();
            return this.param.supportedExtensions.includes(ext);
          });
        }
        return files;
      }
      return [];
    },
    selected() {
      if (this.param.value) {
        return this.datasetFiles.find((df) => {
          return df.id === this.param.value;
        });
      }
      return undefined;
    },
  },
  mounted() {
    this.HTMLSelectElement = HTMLSelectElement;
  },
  methods: {
    async updateDatasetFileField(value) {
      if (this.disabled) return;
      if (this.param.hasChildren) {
        await this.$nuxt.context.store.dispatch('datasets/fetchFileMetadata', {
          datasetId: this.parentValue,
          fileId: value.id,
        });
      }
      await this.$nuxt.context.store.dispatch(
        'parameters/updateDatasetFileSelect',
        {
          projectId: this.projectId,
          scenarioId: this.scenarioId,
          key: this.parameter.key,
          newSelected: value,
        }
      );
    },
  },
};
</script>
